package Common;

#
#   Filename: Common.pm
#   Generated with CodeCharge 1.1.20
#   PerlTemplates build 05/23/2001
#

use DBI;
use TextTemplate;
use strict "vars";

BEGIN {
  use Exporter();
  use vars qw( @ISA @EXPORT @EXPORT_OK );
  @ISA = qw( Exporter );
  @EXPORT = qw(	$page_header
                $strConn
                $dbh
                $RecordsPerPage 
                $path_separator 
                $sAppPath 
                $sHeaderFileName 
                $sFooterFileName 
		%cgi_params
                $username
                $password
		$oTpl
                $is_last_page
		$session_id
		&replace
                &ToHTML 
                &ToURL 
                &get_form_parameters 
                &openrs
                &openrs_arr
                &exec_sql
                &GetParam
                &GetValueHTML
		&getValFromLOV
                &GetValue
		&FormatTime
                &ToSQL
                &DLookUp
                &http_redirect
                &getCheckBoxValue
                &ProceedError
		&IsNumeric
                &GetCookieValue
                &SetCookieHeader
                &ReturnFileContent
                &StartSession
                &SetSessionVar
                &GetSessionVar
                &DelOldTempSessionFiles
                &CheckSecurity );
}

use vars @EXPORT;

$oTpl = TextTemplate->new();
$path_separator = "\\";
$RecordsPerPage = 20;
$sAppPath = substr( $ENV{PATH_TRANSLATED}, 0, rindex( $ENV{PATH_TRANSLATED}, $path_separator ) + 1 );

$sHeaderFileName = $sAppPath . "Header.html";
$sFooterFileName = $sAppPath . "Footer.html";

# Database connection string


  $strConn = "DBI:ODBC:bookstore";
  $username = "";
  $password = "";


sub GetCookieValue {
  my $cookie_name = shift;
  my %cookies = map {$_ =~ /\s*(.+)=(.+)/g} ( split( /;/, $ENV{'HTTP_COOKIE'} ) );
  return $cookies{$cookie_name};
}

sub SetCookieHeader {
  my ($name, $value, $exp_time) = @_;
  return "Set-Cookie: $name=$value; path=/; expires=" . GetStrTime(time() + $exp_time);
}

sub FormatTime {
  my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = @_;
  $hour  = "0" . $hour if ($hour < 10);
  $min   = "0" . $min  if ($min < 10);
  $sec   = "0" . $sec  if ($sec < 10);
  $mday  = "0" . $mday if ($mday < 10);
  $mon++;
  $mon = "0" . $mon if ($mon < 10);
  $year += 1900;
  return "$year-$mon-$mday $hour:$min:$sec";
  # 2001-01-03 06:49:58
}

sub GetStrTime {
  my $time = shift;
  my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = gmtime($time);
  my @months = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
  my @wdays = ("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat");
  $hour  = "0" . $hour if ($hour < 10);
  $min   = "0" . $min  if ($min < 10);
  $sec   = "0" . $sec  if ($sec < 10);
  $mday  = "0" . $mday if ($mday < 10);
  $year += 1900;
  return $wdays[$wday] . ", $mday-" . $months[$mon] . "-$year $hour:$min:$sec GMT";
}

sub StartSession {
  $session_id = GetCookieValue("SessionID");
  if (!defined($session_id) || ($session_id eq "") || !(-e "session_files/$session_id.stmp")) {
    if (!(-d "session_files")) {
      mkdir("session_files", 0744);
    }
    $session_id = GenerateSessionID();
    open(SESSION_FILE, ">session_files/$session_id.stmp");
    close(SESSION_FILE);
  }
  # timeout = 30 min
  $page_header .= SetCookieHeader("SessionID", $session_id, 30*60) . "\n";
}

sub GenerateSessionID {
  srand(time());
  return time()."_".substr(rand(), 2);
}

sub GetSessionVar {
  my ($varName) = @_;
  if (-e "session_files/$session_id.stmp") {
    open(SESSION_FILE, "<session_files/$session_id.stmp");
	my ($name, $value);
	while(<SESSION_FILE>) {
	  chomp;
	  ($name, $value) = split(/=/);
	  if ($name eq $varName) { return $value; }
	}
	close(SESSION_FILE);
	return "";
  } else {
    return "";
  }
}

sub SetSessionVar {
  my ($varName, $varValue) = @_;
  open(SESSION_FILE, "session_files/$session_id.stmp");
  my %vars;
  # read session file
  my ($name, $value);
  while(<SESSION_FILE>) {
    chomp;
    ($name, $value) = split(/=/);
    $vars{$name} = $value;
  }
  # add or change session variable
  $vars{$varName} = $varValue;
  close(SESSION_FILE);
  open(SESSION_FILE, ">session_files/$session_id.stmp");
  while(my ($key, $value) = each(%vars)) {
    print SESSION_FILE "$key=$value\n";
  }
  close(SESSION_FILE);
}

sub DelOldTempSessionFiles {
  my ($temp_session_dir, $session_timeout) = @_;
  opendir(SESSION_TEMP_DIR, $temp_session_dir);
  my (@sessions) = readdir(SESSION_TEMP_DIR); 
  my ( $file_name, $create_date );
  my $age = time() - $session_timeout;
  for $file_name (@sessions) {
    $create_date = substr($file_name,1,index($file_name,"_")-1);
    if ( $create_date < $age && $file_name !~ /^\./ ) {
      unlink ($temp_session_dir.$path_separator.$file_name)
    }
  }
  closedir(SESSION_TEMP_DIR);
}

sub replace {
  my ($source, $find, $replace) = @_;
  $source =~ s/$find/$replace/g;
  return $source;
}

sub get_form_parameters {
  my ( @pairs, %params, $buffer );
  if ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'} );
    @pairs = split(/&/, $buffer);
  } elsif ( $ENV{'REQUEST_METHOD'} eq 'GET' ) {
    @pairs = split (/&/, $ENV{'QUERY_STRING'});
  }
  foreach my $pair (@pairs) {
    my ($name, $value) = split (/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/eg;
    $params{$name} = $value;
  }
  return %params; 
}

sub IsNumeric {
  my $param = shift;
  if ( ($param eq "") or ($param eq "0") ) { return 1 }
  if ( $param =~ /(^\d+\.\d+$|^\d+$|^\d+\.\d+E\d+$)/ ) {
    return $param;
  } else {
    return ""
  }
}
 
sub exec_sql {
  my $sql = shift;
  
  $dbh->{LongReadLen} = 5000;
  my $sth = $dbh->prepare( $sql );
  $sth->execute(); 
}

sub openrs {
  my ( $sql, $cur_page ) = @_;
  
  $dbh->{LongReadLen} = 5000;
  my $sth = $dbh->prepare( $sql );
  $sth->execute(); 

  my @arr_hash_ref;
  $is_last_page = 1;
  if ( !defined($cur_page) ) {
    while ( my $hash_ref = $sth->fetchrow_hashref() ) {
      push (@arr_hash_ref, $hash_ref)
    }
  } else {
    my $i = 1;
    my $from_index = $cur_page + ( $RecordsPerPage - 1 ) * ( $cur_page - 1 ); 
    my $to_index = ( $cur_page + ( $RecordsPerPage - 1 ) * ( $cur_page - 1 ) + ( $RecordsPerPage - 1 ) ) + 1;
    while ( my $hash_ref = $sth->fetchrow_hashref() ) {
      if ( ($i >= $from_index) && ($i <= $to_index ) ) {
        push (@arr_hash_ref, $hash_ref);
          if ( $i == $to_index) {
            $is_last_page = 0;
            pop(@arr_hash_ref);
            last;
          }
      }
      $i++;
    }
  }
  return @arr_hash_ref;
}

sub openrs_arr {
  my ( $sql, $cur_page ) = @_;
  
  $dbh->{LongReadLen} = 5000;
  my $sth = $dbh->prepare( $sql );
  $sth->execute();

  $is_last_page = 1;	
  my @arr;
  if ( !defined($cur_page) ) {
    while ( my @arr_ref = $sth->fetchrow_array() ) {
      push (@arr, \@arr_ref)
    }
  } else {
    my $i = 1;
    my $from_index = $cur_page + ( $RecordsPerPage - 1 ) * ( $cur_page - 1 ); 
    my $to_index = ( $cur_page + ( $RecordsPerPage - 1 ) * ( $cur_page - 1 ) + ( $RecordsPerPage - 1 ) ) + 1;
    while ( my @arr_ref = $sth->fetchrow_array() ) {
      if ( ($i >= $from_index) && ($i <= $to_index ) ) {
        push (@arr, \@arr_ref);
        if ( $i == $to_index) {
          $is_last_page = 0;
          pop(@arr);
          last;
        }
      }
      $i++;
    }
  }
  return @arr;
}

sub ToHTML {
  my $input_string = shift;
  my %convert_hash = ( "<" => "&lt;", "&" => "&amp;", ">" => "&gt;", '"' => "&#34;", "'" => "&#39;" );
  $input_string =~ s/(<|>|&|"|')/$convert_hash{$1}/g;
  return $input_string
}

sub ToURL {
  my $input_string = shift;
  $input_string =~ s/(\W)/sprintf("%%%x", ord($1))/eg;
  return $input_string
}

sub GetValueHTML {
  my ( $ref_rec_hash, $strFieldName ) = @_;
  return ToHTML( $ref_rec_hash->{$strFieldName} );
}

sub GetValue {
  my ( $ref_rec, $strFieldName ) = @_;
  if ( $ref_rec eq "" or $strFieldName eq "" ) { return "" }
  if (ref($ref_rec) eq 'HASH') {
    return $ref_rec->{$strFieldName}
  } elsif (ref($ref_rec) eq 'ARRAY') {
    return $ref_rec->[$strFieldName];
  }
}

sub GetParam {
  my $ParamName = shift;
  my $Param = $cgi_params{ $ParamName };
  if (!defined($Param) or ($Param eq "")) {
    return "";
  } else {
    return $Param;
  }
}

sub ToSQL {
  my ( $Value, $sType ) = @_;
  if ( $Value eq "" ) {
    return "Null"
  } else {
    if ( $sType eq "Number" ) {
      return $Value
    } else {
      $Value =~ s/'/''/g;
      return "'" . $Value . "'"
    }
  }
}

sub DLookUp {
  my ( $Table, $fName, $sWhere ) = @_;
  my $ary_ref = $dbh->selectcol_arrayref( "select " . $fName . " from " . $Table . " where " . $sWhere );
  return $ary_ref->[0]
}

sub getCheckBoxValue {
  my ( $sVal, $CheckedValue, $UnCheckedValue, $sType ) = @_;
  if ( $sVal eq "" ) {
    return ToSQL( $UnCheckedValue, $sType )
  } else {
    return ToSQL( $CheckedValue, $sType )
  }
}

sub getValFromLOV {
  my ($sVal, @aArr) = @_;
  my $sRes = "";
  if ( ($#aArr % 2) == 1 ) {
    for ( my $i = 0; $i <= $#aArr; $i += 2 ) {
      if ( $sVal == $aArr[$i] ) { 
		  $sRes = $aArr[$i+1] 
		}
    }
  }
  return $sRes;
}

sub ProceedError {
  if ( length($DBI::err) != 0 ) {
    return $DBI::err . " " . $DBI::errstr;
  } else {
    return ""
  }
}

sub http_redirect {
  my $dest = shift;
  print "Status: 302 Found\n" .
	    "Location: $dest\n\n";
  exit 0;
}



sub CheckSecurity {
  my $iLevel = shift;
  if ( GetSessionVar("UserID") eq "" ) {
    http_redirect("Login.cgi?querystring=" . ToURL( $ENV{"QUERY_STRING"} ) . "&ret_page=" . ToURL( $ENV{"SCRIPT_NAME"} ) );
  } else {
    if ( GetSessionVar("UserRights") < $iLevel ) { 
      http_redirect("Login.cgi?querystring=" . ToURL( $ENV{"QUERY_STRING"} ) . "&ret_page=" . ToURL( $ENV{"SCRIPT_NAME"} ) );
    }
  }
}



1;